%define summary A commonly used, MIME compliant mail and news reader.
%define name	pine
%define version 4.33
%define release	2mdk
%define exec	%{_bindir}/pine
%define section Networking/Mail

Summary:	%{summary}
Name:		%{name}
Version:	%{version}
Release:	%{release}
Icon:		%{name}.xpm
License:	Distributable
Url:		http://www.washington.edu/pine
Group:		Networking/Mail
BuildRequires:	gpm-devel ncurses-devel pam-devel
Source0:	ftp://ftp.cac.washington.edu/pine/pine%{version}.tar.bz2
Source1:	%{name}_16x16.xpm.bz2
Source2:	%{name}_32x32.xpm.bz2
Source3:	pine.conf
Source4:	flock.c
Source5:	%{name}_48x48.xpm.bz2

Patch0:		pine-4.30-redhat.patch.bz2
Patch5:		pine-4.02-filter.patch.bz2
Patch6:		pine4.04-noflock.patch.bz2

Patch13:	pine-4.21-passwd.patch.bz2
Patch14:	pine-4.21-fixhome.patch.bz2
Patch15:	imap-4.7c2-flock.patch.bz2
Patch16:	pine-4.31-openssl.patch.bz2
Patch18:	pine-4.31-segfix.patch.bz2
# (vdanen) I don't think is needed since 4.33; keep in case
Patch19:	pine-4.30-sparc.patch.bz2

Patch20:	pine-4.30-boguswarning.patch.bz2
# (gb) temporary fix for missing includes before upgrading to 4.33+
Patch21:	pine4.30-missing-includes.patch.bz2
Patch22:	pine-4.30-ldap.patch.bz2
Patch23:	pine-4.31-lockfile-perm.patch.bz2
# (vdanen) includes old pine4.10-c-client_directory_with_driver.patch
Patch24:	pine-maildir-4.33.patch.bz2
Patch25:	pine-4.33-keymenu.patch.bz2
Patch26:	imap-2000-time.patch.bz2

BuildRequires:	perl, openssl-devel
Buildroot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
Pine is a very popular, easy to use, full-featured email user agent
which includes a simple text editor called pico. Pine supports MIME
extensions and can also be used to read news.  Pine also supports
IMAP, mail and MH style folders.

Pine should be installed because Pine is a very commonly used email
user agent and it is currently in development.

%prep
%setup -q -n %{name}%{version}

%patch0 -p1 -b .rh
%patch5 -p1 -b .filter
%patch6 -p1 -b .noflock

%patch13 -p1 -b .passwd
%patch14 -p1 -b .fixhome

pushd imap
%patch15 -p1 -b .flock
cp %{SOURCE4} src/osdep/unix
popd

%patch16 -p1 -b .openssl
%patch18 -p1 -b .segfix
#%patch19 -p1 -b .sparc
%patch20 -p1 -b .bogus
%patch21 -p1 -b .includes
%patch22 -p1 -b .ldap
%patch23 -p1 -b .lockfile

# (vdanen) maildir patch, must be applied after imap patch
%patch24 -p1 -b .maildir

%patch25 -p1 -b .keymenu
%patch26 -p1 -b .imaptime

# this wants /usr/local/bin/perl
chmod 644 contrib/utils/pwd2pine
perl -pi -e "s|/usr/local/bin/perl|/usr/bin/perl|" contrib/utils/pwd2pine

# build ssl support
# FIXME: for some reason ssl support is kinda whacked.  Included in patch0
# is some stuff for the Makefile.ssl that might be wrong as well.  There may
# also be a conflict between SSL support and the maildir patch.
# (vdanen) enabled for testing (4.33-1mdk)
perl -pi -e "s|/usr/local/ssl|/usr/lib/ssl|" build

%build
%ifarch %ix86
# (gb) there are still some problems with strength reduction in gcc...
no_strength_reduce="-fno-strength-reduce"
%else
no_strength_reduce=""
%endif

perl -pi -e "s|(-g )?-fno-omit-frame-pointer -O6|$RPM_OPT_FLAGS ${no_strength_reduce}|g" \
	./imap/src/imapd/Makefile \
	./imap/src/ipopd/Makefile \
	./imap/src/mtest/Makefile \
	./imap/src/osdep/unix/Makefile \
	./imap/Makefile \
	./imap/tools/Makefile

./build	DEBUG="" \
	OPTIMIZE="$RPM_OPT_FLAGS ${no_strength_reduce}" \
	EXTRACFLAGS="-DIGNORE_LOCK_EACCES_ERRORS" \
	SPECIALAUTHENTICATORS=ssl \
	lnp

%install
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
mkdir -p %{buildroot}%{_bindir} %{buildroot}%{_mandir}/man1
mkdir -p %{buildroot}%{_defaultdocdir} %{buildroot}%{_libdir}
install -m 644 doc/mime.types %{buildroot}%{_libdir}/mime.types
for n in pine pico pilot; do
    install -m 755 -s bin/$n %{buildroot}%{_bindir}/$n
done

cd doc
for n in pine.1 pico.1 pilot.1; do
    install -m 644 $n %{buildroot}%{_mandir}/man1
done
mkdir -p %{buildroot}%{_sysconfdir}
install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/pine.conf

cat <<EOF > %{buildroot}%{_sysconfdir}/pine.conf.fixed
#
# Pine system-wide enforced configuration file - customize as needed
#
# This file holds the system-wide enforced values for pine configuration
# settings. Any values set in it will override values set in the
# system-wide default configuration file (/etc/pine.conf) and
# the user's own configuration file (~/.pinerc).
# For more information on the format of this file, read the
# comments at the top of /usr/lib/pine.conf

EOF

# icons
mkdir -p %{buildroot}%{_miconsdir}
mkdir -p %{buildroot}%{_liconsdir}
bzcat %{SOURCE1} > %{buildroot}%{_miconsdir}/%{name}.xpm
bzcat %{SOURCE2} > %{buildroot}%{_iconsdir}/%{name}.xpm
bzcat %{SOURCE5} > %{buildroot}%{_liconsdir}/%{name}.xpm

# menu entries (pine & pico)
mkdir -p %{buildroot}%{_menudir}
cat >%{buildroot}%{_menudir}/%{name} <<EOF
?package(%{name}):\\
	command="%{exec}"\\
	needs="text"\\
	icon="%{name}.xpm"\\
	section="%{section}"\\
	title="Pine"\\
	longtitle="Pine: %{summary}"
?package(%{name}):\\
	command="%{_bindir}/pico"\\
	needs="text"\\
	icon="%{name}.xpm"\\
	section="Applications/Editors"\\
	title="Pico"\\
	longtitle="Pico: default editor for pine"
EOF

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
#rm -rf $RPM_BUILD_DIR/%{name}%{version}

%post
## add menu entry 
%update_menus

%postun
## remove menu entry 
%clean_menus

%files
%defattr(-,root,root)
%doc README CPYRIGHT doc/*.txt doc/pine-ports doc/tech-notes doc/mailcap.unx imap/docs/bugs.txt
%doc contrib
%{_bindir}/pine
%{_bindir}/pico
%{_bindir}/pilot
%{_mandir}/man1/*
%attr(0644,root,root)	%{_libdir}/mime.types
%attr(0644,root,root)	%config(noreplace) %{_sysconfdir}/pine.conf
%attr(0644,root,root)	%config(noreplace) %{_sysconfdir}/pine.conf.fixed

%defattr(0644,root,root)
%{_menudir}/%{name}
%{_iconsdir}/%{name}.xpm
%{_miconsdir}/%{name}.xpm
%{_liconsdir}/%{name}.xpm


%changelog
* Thu Jun 28 2001 Vincent Danen <vdanen@mandrakesoft.com> 4.33-2mdk
- add BuildRequires: pam-devel

* Wed Apr 25 2001 Vincent Danen <vdanen@mandrakesoft.com> 4.33-1mdk
- 4.33
- sync patches with rh
- new maildir patch
- re-enable ssl to see if works better now

* Fri Apr 13 2001 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 4.30-4mdk
- sanitized specfile (s/Copyright/License, BuildRequires, etc.)
- added missing includes in imap/src/osdep/os_lnx.h (patch21)
- rebuilt for post LDMDK 8.0 with -fno-strength-reduce on ix86
- completely got rid of -O6 optimization flag

* Fri Nov 10 2000 Vincent Danen <vdanen@mandrakesoft.com> 4.30-3mdk
- merge with Red Hat
- use lnp (PAM auth) insteaf of slx (crypt)
- some spec fixes
- enable SSL
- make config files noreplace
- added large icon
- bzip patches and icons


* Thu Nov 09 2000 Vincent Danen <vdanen@mandrakesoft.com> 4.30-2mdk
- patch to correct pine crashing and check extra NULL pointers from RH

* Tue Nov 07 2000 Vincent Danen <vdanen@mandrakesoft.com> 4.30-1mdk
- 4.30
- security fix for incoming mailbox handling
- remove hardcoded icon directory in menus

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 4.21-6mdk
- automatically added BuildRequires

* Thu Aug 03 2000 Geoffrey Lee <snailtalk@mandrakesoft.com> 4.21-5mdk
- rebuild for BM
- rebuild with macros
- tmppath
* Sun Apr 09 2000 Denis HAvlik <denis@mandrakesoft.com> 4.21-4mdk
- Group: Networking/Mail
- pine-tree icon + menu entries (for pine + pico)
- spec-helper

* Sat Feb 19 2000 Geoffrey Lee <snailtalk@linux-mandrake.com> 4.21-3mdk
- make patch to change os-lnx.h from /bin/passwd to /usr/bin/passwd

* Tue Dec 14 1999 John Buswell <johnb@mandrakesoft.com>
- add new maildir patches
- add vfs patch
- fixed non-existant directory seek problem (bug:#506)

* Tue Nov 30 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- 4.21.
- Merge with recent redhat changes.

* Tue Nov 02 1999 John Buswell <johnb@mandrakesoft.com>
- Rebuild and Repackage for oxygen (release 2)

* Thu Oct 14 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- 4.20
- sync with RH

* Thu Aug 12 1999 Cristian Gafton <gafton@redhat.com>
- add maildir patch

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 2)

* Fri Feb 26 1999 Cristian Gafton <gafton@redhat.com>
- fix buildroot and add cleanup section
- move config files to /etc/pine.conf

* Tue Feb 02 1999 Preston Brown <pbrown@redhat.com>
- turned off .pine-debugX files

* Thu Dec 17 1998 Cristian Gafton <gafton@redhat.com>
- build against glibc 2.1

* Fri Nov 13 1998 Cristian Gafton <gafton@redhat.com>
- patch to enable SIGWINCH processing (why do the pine folks keep 
  disabling this stuff?!)

* Fri Oct 09 1998 Cristian Gafton <gafton@redhat.com>
- use termios instead of termio (patch used to be in here...)
- use terminfo instead of termcap and link against ncurses instead of termcap
- supply -lcrypt as a standard lib

* Sat Sep 19 1998 Jeff Johnson <jbj@redhat.com>
- upgrade to 4.04 (compatibility with some client imaps).

* Fri Sep 11 1998 Jeff Johnson <jbj@redhat.com>
- use only fcntl locking.

* Thu Sep 10 1998 Jeff Johnson <jbj@redhat.com>
- update to 4.03

* Fri Aug 14 1998 Jeff Johnson <jbj@redhat.com>
- patch to 4.02A.
- disable stupid EACCESS warnings.

* Wed Jul 22 1998 Jeff Johnson <jbj@redhat.com>
- update to 4.02.

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Thu Jan 15 1998 Erik Troan <ewt@redhat.com>
- added patch to fix pine filters

* Tue Dec 30 1997 Erik Troan <ewt@redhat.com>
- fixed resizing in pine and pico

* Thu Dec 18 1997 Erik Troan <ewt@redhat.com>
- removed patch for SIGCHLD race -- it shouldn't be necessary
- added patch to avoid longjmp() from SIGCHLD handler -- SIGCHLD handling
  is sane now

* Thu Dec 11 1997 Cristian Gafton <gafton@redhat.com>
- added a patch for handling a SIGCHLD race condition

* Tue Nov 04 1997 Erik Troan <ewt@redhat.com>
- fix for locks w/ long st_dev field
- use termios rather then termio

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added wmconfig entry

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- removed exec bit from /usr/doc/pine-3.96-1/contrib/utils/pwd2pine
